diff -uNr trunk/encoder/encoder.c trunk-new/encoder/encoder.c
--- trunk/encoder/encoder.c	Tue Nov 20 02:57:28 2007
+++ trunk-new/encoder/encoder.c	Sat Dec 22 20:38:01 2007
@@ -615,7 +615,7 @@
     x264_reduce_fraction( &h->param.i_fps_num, &h->param.i_fps_den );
 
     /* Init x264_t */
-    h->i_frame = 0;
+    h->i_frame = -1;
     h->i_frame_num = 0;
     h->i_idr_pic_id = 0;
 
@@ -942,9 +942,6 @@
 {
     int i;
 
-    if( h->fdec->i_frame >= 0 )
-        h->i_frame++;
-
     if( !h->fdec->b_kept_as_ref )
     {
         if( h->param.i_threads > 1 )
@@ -1314,6 +1311,7 @@
         }
     }
 
+    h->i_frame++;
     if( h->frames.current[0] == NULL )
     {
         int bframes = 0;
@@ -1774,6 +1772,16 @@
         // don't strictly have to wait for the other threads, but it's simpler than cancelling them
         if( h->thread[i]->b_thread_active )
             x264_pthread_join( h->thread[i]->thread_handle, NULL );
+    }
+
+    if( h->param.i_threads > 1)
+    {
+        x264_t *thread_prev;
+
+        thread_prev = h->thread[ h->i_thread_phase % h->param.i_threads ];
+        x264_thread_sync_ratecontrol( h, thread_prev, h );
+        x264_thread_sync_ratecontrol( thread_prev, thread_prev, h );
+        h->i_frame = thread_prev->i_frame + 1 - h->param.i_threads;
     }
 
 #ifdef DEBUG_BENCHMARK
diff -uNr trunk/encoder/ratecontrol.c trunk-new/encoder/ratecontrol.c
--- trunk/encoder/ratecontrol.c	Wed Sep 12 02:42:22 2007
+++ trunk-new/encoder/ratecontrol.c	Sat Dec 22 20:40:34 2007
@@ -358,16 +358,13 @@
             x264_log( h, X264_LOG_WARNING, "2nd pass has fewer frames than 1st pass (%d vs %d)\n",
                       h->param.i_frame_total, rc->num_entries );
         }
-        if( h->param.i_frame_total > rc->num_entries + h->param.i_bframe )
+        if( h->param.i_frame_total > rc->num_entries )
         {
             x264_log( h, X264_LOG_ERROR, "2nd pass has more frames than 1st pass (%d vs %d)\n",
                       h->param.i_frame_total, rc->num_entries );
             return -1;
         }
 
-        /* FIXME: ugly padding because VfW drops delayed B-frames */
-        rc->num_entries += h->param.i_bframe;
-
         rc->entry = (ratecontrol_entry_t*) x264_malloc(rc->num_entries * sizeof(ratecontrol_entry_t));
         memset(rc->entry, 0, rc->num_entries * sizeof(ratecontrol_entry_t));
 
@@ -382,7 +379,7 @@
 
         /* read stats */
         p = stats_in;
-        for(i=0; i < rc->num_entries - h->param.i_bframe; i++){
+        for(i=0; i < rc->num_entries; i++){
             ratecontrol_entry_t *rce;
             int frame_number;
             char pict_type;
@@ -602,7 +599,7 @@
     if( rc->p_stat_file_out )
     {
         fclose( rc->p_stat_file_out );
-        if( h->i_frame >= rc->num_entries - h->param.i_bframe )
+        if( h->i_frame >= rc->num_entries )
             if( rename( rc->psz_stat_file_tmpname, h->param.rc.psz_stat_out ) != 0 )
             {
                 x264_log( h, X264_LOG_ERROR, "failed to rename \"%s\" to \"%s\"\n",